comment * 

Chat 1.5 UdeM   Desarrollado por: Richard Machado
                                  Daniel Morales
Profesor: Jairo Vergara 

Arquitectura del computador - 16/Mar/2005

 *

    .486                                    ; Crea codigo de 32 bits
    .model flat, stdcall                    ; 32 bit Modelo de memoria
    option casemap :none                    ; case sensitive
 
    include \masm32\include\windows.inc     ; Librerias de windowns
    include \masm32\macros\macros.asm       ; Macros preconstruidos

  ; --------------------------------------------------
  ; include archivos para el llamado de las funciones
  ; --------------------------------------------------
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\wsock32.inc

  ; ------------------------------------------------
  ; Librerias con funciones 
  ; ------------------------------------------------
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\wsock32.lib

  ; ----------------------------------------------------
  ; Procedimiento para mostrar variables por pantalla
  ; ----------------------------------------------------

    show_text PROTO :DWORD
    inicializar PROTO 
    listen PROTO :DWORD,:DWORD
    envia PROTO 
    recibe PROTO 
  ; ----------------------------------------------------
  ; Segmento de Datos
  ; ----------------------------------------------------

.data
AppName db "Connect",0

;Mesajes de estado:
PasConnecte db "No conectado",0
Connecte db "Conectado",0
Deconnecter db "Desconectado",0
Connecter db "&Conectado",0

;Puerto de conexin del socket
Port dd 3030

; Vectores de envio y recepcin de informacin
Connected db 0
;BytSend db 1024 dup (0)
;BytRecu db 1024 dup (0)

;IP temporal
IPTmp db 4 dup(0)

;Manejo de direccionamiento IP
;AdresseIP db "127.0.0.1",0
BytSend db "Envio de prueba",0
BytRecu db "Recibi",0
IPPasRempli db "Verifique la direccin IP",0
IPPT db ".",0

;IP db "192.168.0.4",0
 WSAdata WSADATA<>

; -----------------
;Segmento de datos
; -----------------

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
buffer db 512 dup(?)
hDlg   dd ?
hDlg2  dd ?

; -----------------------------
;Variables y manejo de sockects
; -----------------------------

;WSAdata WSADATA<>
sin sockaddr_in <>

hSocket	 dd ?
hSocket2	 dd ?
hClient	 dd ?

Buffy1 db 512 dup(?)
Buffy2 db 512 dup(?)
Buffy3 db 512 dup(?)
Buffy4 db 512 dup(?)

hEdit1	 dd ?
hEdit2	 dd ?
hRichEdit	 dd ?
lpfnEditProc dd ?
hMenu		 dd ?

WM_SOCKET equ WM_USER+100 


    .code                       

; 

start:                          

    call main                   
    exit

; 

main proc

LOCAL   txtinput:DWORD        
LOCAL      hostt:DWORD
LOCAL  AdressIPt:DWORD
LOCAL       str3:DWORD


    print chr$("--------------------------------------------------",13,10)
    print chr$(" ",13,10)
    print chr$("          Bienvenido: chat 1.5 - UdeM             ",13,10)
    print chr$(" ",13,10)    
    print chr$("--------------------------------------------------",13,10)
    print chr$("Para ingresar Direccion IP pulse:1 y luego pulse ENTER",13,10)
    print chr$("Para ingresar Host pulse        :2 y luego pulse ENTER",13,10)
    print chr$("--------------------------------------------------",13,10)
    print chr$(" ",13,10)  
    mov str3, sval(input("Ingrese Opcion:"))
    print chr$(" ",13,10)  
    print chr$("--------------------------------------------------",13,10)
    mov eax, str3

    .if eax==1
	 mov AdressIPt, input("Ingrese la direccion IP:")
       invoke show_text, AdressIPt
       print chr$("--------------------------------------------------",13,10)
    .else
       mov hostt, input("Ingrese la direccion Host:")
       invoke show_text, hostt
       print chr$("--------------------------------------------------",13,10)

    .endif
       invoke inicializar   
       invoke listen, AdressIPt, hostt
       invoke envia 
       invoke recibe 

main endp

; -------------------------------------------------------------------------

show_text proc string:DWORD

; ver el string por consola
    print chr$(" ",13,10,"*")
    print string                
    print chr$("*",13,10)
    print chr$(" ",13,10)
    ret

show_text endp

; -------------------------------------------------------------------------

inicializar proc 
 ;Inicializa el DLL WindSock v1.1

    INVOKE WSAStartup,101h,ADDR WSAdata
    print chr$(" ",13,10)
    .if eax!=NULL
        print chr$("Error al inicializar el dll WindSock.",13,10)
	  mov hSocket2,eax 
    .endif
    
inicializar endp

; -------------------------------------------------------------------------

listen proc AdressIP:DWORD, host:DWORD

;Creo socket para la comunicacion
    invoke socket,AF_INET,SOCK_STREAM,0
    ;Verifico que el sockect sea valido

    ;.if eax!=INVALID_SOCKET 
	; mov hSocket2,eax 
    ;.else
       ; print chr$("Error al conectar. Intente de nuevo.",13,10)
    ;.endif


    ;Verifico si el puerto esta disponible	
    ;invoke WSAAsyncSelect, hSocket2, 0,WM_SOCKET, FD_ACCEPT+FD_READ
    ;.if eax==INVALID_SOCKET 
    ;print chr$("A ocurrido un error inesperado en la red.",13,10)
    ;.endif

    invoke socket,AF_INET,SOCK_STREAM,0

    ;Escucho al puerto
    
    ;invoke htons, Port
    ;mov sin.sin_port, Port
    mov sin.sin_port, ax
    mov sin.sin_family, AF_INET 
    ;invoke inet_addr, addr AdressIP
    mov sin.sin_addr, INADDR_ANY
    invoke bind, hSocket2, addr sin, sizeof sin
    invoke listen, hSocket2, 5

    ;Aceptar socket
    invoke accept,hSocket2,0,0 
    ;conectar 
    invoke connect, hSocket, addr sin, sizeof sin
    ;Capturar host
    ;invoke gethostname,addr Buffy1,512 
    ;CERRAR SOCKET
    ;invoke closesocket, hSocket
    
listen endp

; -------------------------------------------------------------------------

envia proc 
LOCAL   S:DWORD 

    mov S, input("ENV:")
    invoke lstrlen, addr S
    
    .if eax<1024

        invoke send, hSocket, addr S, 1024, 0

        .if eax==SOCKET_ERROR
		print chr$("ERROR: La conexion se perdio.",13,10)
	  .endif  

    .endif

envia endp

; -------------------------------------------------------------------------

recibe proc 

    print chr$("REC:")
    invoke lstrlen, addr BytRecu
    ;mov str2, BytRecu
    
    .if eax<1024   
        invoke recv, hClient, addr BytRecu, 1024,0
        print BytRecu
        .if eax==SOCKET_ERROR
	       print chr$("ERROR: La conexion se perdio.",13,10)
        .endif  
    .endif

recibe endp

; -------------------------------------------------------------------------

end start      